#include <J3ML/LinearAlgebra/Vector3.h>

#pragma once

namespace Geometry {
    using Point2D = LinearAlgebra::Vector2;

    class LineSegment2D
    {
        Point2D A;
        Point2D B;
    };

    class Rectangle; //AABB2D;
    class OBB2D;
    class Line2D;
    class Ray2D;
    class Triangle2D;
    class Polygon2D;

    struct IntersectionResult2D {

    };

    bool Intersects2D(LineSegment2D seg, Rectangle rect);
    IntersectionResult2D GetIntersection2D(LineSegment2D seg, Rectangle rect);



    

    using Point3D = LinearAlgebra::Vector3;

    // A 3D axis-aligned bounding box
    // This data structure can be used to represent coarse bounds of objects, in situations where detailed triangle-level
    // computations can be avoided. In physics systems, bounding boxes are used as an efficient early-out test for geometry
    // intersection queries.
    // the 'Axis-aligned' part in the name means that the local axes of this bounding box are restricted to align with the
    // axes of the world space coordinate system. This makes computation involving AABB's very fast, since AABB's cannot
    // be arbitrarily oriented in the space with respect to each other.
    // If you need to represent a box in 3D space with arbitrary orientation, see the class OBB. */
    class AABB;
    class Capsule;
    class Line;
    class LineSegment
    {
        Point3D A;
        Point3D B;
    };
    class Ray
    {
        Point3D Origin;
        Point3D Direction;
    };

    class OBB;
    class Frustum;
    class Plane;
    class Polygon;
    class Polyhedron;
    class QuadTree;
    class OctTree;
    class Sphere;
    class Triangle;
    class TriangleMesh;
}